<template>
  <div class="navbar">
    <b-navbar
      :shadow="true"
      class="has-background-primary"
      style="box-shadow: 0px 4px 6px #00000029; position: fixed"
    >
      <template #brand>
        <b-navbar-item @click="$emit('toggle-sidebar')">
          <b-icon
            style="color: white"
            icon="bars"
            size="is-large"
          />
        </b-navbar-item>
      </template>
      <template #start>
        <div
          class="title is-flex"
          style="align-items: center"
        >
          <router-link :to="{ path: '/after-login' }">
            <p class="title-navbar">
              21 Plus - POS
            </p>
          </router-link>
        </div>
      </template>

      <template #end>
        <div
          id="profileNavbar"
          class="is-flex pointer"
          style="align-items: center; margin-right: 18px"
        >
          <figure class="image is-64x64">
            <b-image
              v-if=" currentUser.user.profilePicture ==null"
              :src="'/images/default-profile-picture.png'"
              style="margin-left: auto;margin-right: auto;"
              rounded
              alt="profile picture"
            />
            <b-image
              v-else
              :src="digiCentreURL +'/storage' + currentUser.user.profilePicture"
              style="margin-left: auto;margin-right: auto;"
              rounded
              alt="profile picture"
              @error="
                $event.target.src = require('/images/default-profile-picture.png')
              "
            />
          </figure>
        </div>
      </template>
    </b-navbar>
    <div
      id="profileTooltip"
      class="tooltip"
    >
      <div class="columns">
        <div class="column is-3">
          <figure class="image is-64x64">
            <b-image
              v-if=" currentUser.user.profilePicture ==null"
              :src="'/images/default-profile-picture.png'"
              style="margin-left: auto;margin-right: auto;"
              rounded
              alt="profile picture"
            />
            <b-image
              v-else
              :src="digiCentreURL + '/storage' + currentUser.user.profilePicture"
              style="margin-left: auto;margin-right: auto;"
              rounded
              alt="profile picture"
              @error="
                $event.target.src = require('/images/default-profile-picture.png')
              "
            />
          </figure>
        </div>
        <div class="column is-9">
          <div class="columns">
            <div
              class="column"
            >
              Name:
            </div>
            <div
              class="column"
            >
              {{ currentUser.user.name }}
            </div>
          </div>
          <div class="columns">
            <div
              class="column"
            >
              Role:
            </div>
            <div
              class="column"
            >
              {{ currentUser.user.role.name }}
            </div>
          </div>
          <div class="columns">
            <div class="column">
              <span> Start from:</span>
            </div>
            <div class="column">
              <span class="has-text-right">{{ currentUser.user.latestLogin.createdAt |dateFormat('HH:mm') }}</span>
            </div>
          </div>
        </div>
      </div>
      <div class="columns">
        <div class="column">
          <b-button
            type="is-primary"
            outlined
            expanded
            @click="logout()"
          >
            Logout
          </b-button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';

export default {
  data () {
    return {
      digiCentreURL: process.env.MIX_APP_URL_21_PLUS_CENTRE,
    };
  },
  mounted () {
    this.toggleTooltip();
  },
  methods: {
    logout () {
      this.$store
        .dispatch('logout')
        .then(() => {
          this.$buefy.toast.open({
            message: 'Berhasil Logout',
            type: 'is-success'
          });
          this.$router.push('/login');
        })
        .catch((err) => {
          alert(err);
        });
    },
    //* activated from the parent component
    toggleTooltip () {
      //* script to enable visibility tooltip
      const profileNavbar = document.getElementById('profileNavbar');
      const tooltip = document.getElementById('profileTooltip');

      //* toggle tooltip whenever clicked on profileTooltip
      profileNavbar.onclick = () => {
        if (tooltip.style.visibility === 'visible') {
          tooltip.style.visibility = 'hidden';
        } else {
          tooltip.style.visibility = 'visible';
        }
      };

      //* make tooltip hidden whenever click on page
      const parent = this.$parent;
      parent.$refs.myHome.onclick = () => {
        if (tooltip.style.visibility === 'visible') {
          tooltip.style.visibility = 'hidden';
        }
      };

      //* make tooltip hidden whenever click on  navbar-start
      const navbarStart = document.querySelector(
        '.navbar .navbar-start'
      );
      navbarStart.onclick = () => {
        if (tooltip.style.visibility === 'visible') {
          tooltip.style.visibility = 'hidden';
        }
      };

      //* make tooltip hidden whenever click on  navbar-brand
      const navbarBrand = document.querySelector(
        '.navbar .navbar-brand'
      );
      navbarBrand.onclick = () => {
        if (tooltip.style.visibility === 'visible') {
          tooltip.style.visibility = 'hidden';
        }
      };
    }
  },
  computed: {
    // mix the getters into computed with object spread operator
    ...mapGetters(['currentUser'])
  }
};
</script>

<style scoped>
.navbar {
  width: 100%;
  height: 90px;
  padding-right: 8px;
  position: relative;
}

.title-navbar {
  color: white;
  font-size: 30px;
  font-weight: 600;
  text-decoration: none;
}

.tooltip {
  visibility: hidden;
  width: 340px;
  margin-top: 90px;
  background-color: #ffffff;
  border: 1px solid black;
  padding: 22px 15px 15px 15px;
  text-align: left;
  clip-path: inset(0px -20px -20px -20px);
  /* Position the tooltip */
  position: fixed;
  right: 0px;
  top: -5px;
  z-index: 10;
}

.pointer {
  cursor: pointer;
}

.status {
  justify-content: space-between;
  align-items: center;
}
</style>
